//  引入element ui
import Element from 'element-ui'
import 'element-ui/lib/theme-chalk/index.css'

// 引入组件
import components from './components'
// 公共方法
import common from "./utils";
// 公共样式
import './style/index.scss'
// 注册
const install = function(Vue, opts = {}) {

    Vue.use(Element, opts || { size: 'mini'});

    components.forEach(com => {
        Vue.component(com.name, com);
    })

    common.forEach(com => {
        Vue.prototype[com.name] = com.value
    })

    console.info('...lab...')
}

/* 支持使用标签的方式引入 */
if (typeof window !== 'undefined' && window.Vue) {
    install(window.Vue);
}

// 导出
export default {
    install
}
