import Vue from 'vue'
import App from './App.vue'
import store from './store';
import Element from 'element-ui';
import 'element-ui/lib/theme-chalk/index.css';
import './style/index.scss'

// 引入组价
import components from '@/components/index'
// 引入方法
import common from "@/utils";

Vue.use(Element, { size: 'mini' });
components.forEach(com => {
  Vue.component(com.name, com);
})
common.forEach(com => {
  Vue.prototype[com.name] = com.value
})

Vue.config.productionTip = false

new Vue({
  store,
  render: h => h(App),
}).$mount('#app')
