import LabDesign from "./LabDesign";

export default {
    mixins: [LabDesign],
    inject: {
        /**
         * 父级组件对象
         */
        parentElement: {
            from: 'parentElement',
            default: function () {
                return null
            }
        },
        /**
         * 当前组件所属视图对象
         */
        parentView: {
            from: 'parentView',
            default: function () {
                return null
            }
        }
    },
    props: {
        /**
         * 当前组件
         */
        element: {
            type: Object,
            default: function () {
                return { elements: [] }
            }
        },
        /**
         *  当前组件所属的集合
         */
        elements: {
            type: Array,
            default: function () {
                return []
            }
        },
        /**
         * 当前组件在所属集合的索引下标
         */
        index: {
            type: Number,
            default: -1
        },
        /**
         * 当前业务对象
         */
        modelData: {
            type: Object,
            default: function () {
                return { }
            }
        }
    },
    data () {
        return {
            /**
             * 当前样式
             */
            selfStyle: {},
            /**
             * 当前数据模式，优先从父级组件获取
             * add、edit、view、hide
             */
            selfType: 'edit'

        }
    },
    created() {
        this.selfStyle = this.$Util.copy(this.element.style)
        if (this.element.selfType) {
            this.selfType = this.element.selfType
        }/* else if (this.parentElement) {
            this.selfType = this.parentElement.selfType
        }*/
        if (this.element.render === 'divider') {
            this.element.labelWidth = '0'
        }
    }
}
